package com.glxp.api.admin.service.auth.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.auth.AuthAdminDao;
import com.glxp.api.admin.dao.auth.AuthCheckDao;
import com.glxp.api.admin.entity.auth.AuthCheckEntity;
import com.glxp.api.admin.req.auth.AuthCheckRequest;
import com.glxp.api.admin.service.auth.AuthCheckService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class AuthCheckServiceImpl implements AuthCheckService {
    @Resource
    private AuthCheckDao authCheckDao;

    @Override
    public AuthCheckEntity findByMachine(String machineInfo) {
        return authCheckDao.findByMachine(machineInfo);
    }

    @Override
    public List<AuthCheckEntity> filterDevices(AuthCheckRequest authCheckRequest) {
        if (authCheckRequest == null) {
            return Collections.emptyList();
        }
        if (authCheckRequest.getPage() != null) {
            int offset = (authCheckRequest.getPage() - 1) * authCheckRequest.getLimit();
            PageHelper.offsetPage(offset, authCheckRequest.getLimit());
        }
        return authCheckDao.filterDevices(authCheckRequest);
    }

    @Override
    public boolean insertDevices(AuthCheckEntity authCheckEntity) {
        return authCheckDao.insertDevices(authCheckEntity);
    }

    @Override
    public boolean updateDevices(AuthCheckEntity authCheckEntity) {
        return authCheckDao.updateDevices(authCheckEntity);
    }
}
