package com.glxp.api.admin.service.basic.impl;

import cn.hutool.core.collection.CollUtil;
import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UdiInfoDao;
import com.glxp.api.admin.dao.basic.UdiInfoImportDetailDao;
import com.glxp.api.admin.dao.basic.UdiRelevanceDao;
import com.glxp.api.admin.dao.thrsys.ThrProductsDao;
import com.glxp.api.admin.entity.basic.UdiInfoImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.res.basic.UdiRelevanceExportJsonResponse;
import com.glxp.api.admin.service.basic.UdiInfoImportDetailService;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiInfoImportDetailServiceImpl implements UdiInfoImportDetailService {

    @Resource
    UdiInfoImportDetailDao udiInfoImportDao;
    @Resource
    UdiInfoDao udiInfoDao;
    @Resource
    UdiRelevanceDao udiRelevanceDao;
    @Resource
    ThrProductsDao thrProductsDao;

    @Override
    public List<UdiInfoImportDetailEntity> filterUdiInfoImport(FilterUdiIpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<UdiInfoImportDetailEntity> data = udiInfoImportDao.filterUdiInfoImport(filterInCodeLogRequest);
        return data;

    }


    @Override
    public boolean insertUdiInfoImport(UdiInfoImportDetailEntity udiInfoImportEntity) {
        return udiInfoImportDao.insertUdiInfoImport(udiInfoImportEntity);
    }

    @Override
    public boolean updateUdiInfoImport(UdiInfoImportDetailEntity udiInfoImportEntity) {
        return udiInfoImportDao.updateUdiInfoImport(udiInfoImportEntity);
    }

    @Override
    public boolean insertUdiInfoImports(List<UdiInfoImportDetailEntity> udiInfoImportEntities) {
        return udiInfoImportDao.insertUdiInfoImports(udiInfoImportEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return udiInfoImportDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return udiInfoImportDao.deleteByGenkey(genKey);
    }

    @Override
    @Async
    public void importJsonData(UdiRelevanceExportJsonResponse udiRelevanceExportJsonResponse) {
        if (CollUtil.isNotEmpty(udiRelevanceExportJsonResponse.getUdiInfoEntities())) {
            udiInfoDao.importUdiInfo(udiRelevanceExportJsonResponse.getUdiInfoEntities());
        }

        if (CollUtil.isNotEmpty(udiRelevanceExportJsonResponse.getUdiRelevanceEntities())) {
            udiRelevanceDao.importUdiRelevance(udiRelevanceExportJsonResponse.getUdiRelevanceEntities());
        }

        if (CollUtil.isNotEmpty(udiRelevanceExportJsonResponse.getThrProductsEntities())) {
            thrProductsDao.importThrProductss(udiRelevanceExportJsonResponse.getThrProductsEntities());
        }
    }
}
