package com.glxp.api.admin.service.business;


import com.glxp.api.admin.entity.business.StockOrderEntity;
import com.glxp.api.admin.entity.business.StockOrderPrintEntity;
import com.glxp.api.admin.req.business.StockOrderFilterRequest;
import com.glxp.api.admin.req.business.StockOrderQueryRequest;
import com.glxp.api.admin.res.business.StockOrderExportResponse;

import java.util.List;

public interface StockOrderService {

    List<StockOrderEntity> listStockOrders(StockOrderQueryRequest stockOrderQueryRequest);

    List<StockOrderEntity> listStockOrderNoDealWith(StockOrderQueryRequest stockOrderQueryRequest);

    boolean insertStockOrder(StockOrderEntity orderEntity);

    boolean updateById(StockOrderEntity stockOrderEntity);

    boolean deleteByOrderId(String orderId);

    boolean deleteById(String id);

    boolean updateByStatus(String orderId, Integer status);

    List<StockOrderEntity> findAllOrders(StockOrderFilterRequest stockOrderFilterRequest);

    List<StockOrderEntity> filterListOr(StockOrderFilterRequest stockOrderFilterRequest);

    StockOrderEntity findOne(StockOrderFilterRequest stockOrderFilterRequest);

    StockOrderEntity findById(String orderId);

    StockOrderEntity findByBillNo(String orderId);


    List<StockOrderPrintEntity> listOrderPrint(String orderId);

    /**
     * 导出已验收单据信息
     *
     * @param request
     * @return
     */
    List<StockOrderExportResponse> exportOrderData(StockOrderFilterRequest request);
}
