package com.glxp.api.admin.service.business.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.business.StockOrderDetailDao;
import com.glxp.api.admin.entity.business.StockOrderDetailEntity;
import com.glxp.api.admin.req.business.StockOrderDetailFilterRequest;
import com.glxp.api.admin.res.business.StockOrderDetailResponse;
import com.glxp.api.admin.service.business.StockOrderDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class StockOrderDetailServiceImpl implements StockOrderDetailService {

    @Resource
    StockOrderDetailDao stockOrderDetailDao;

    @Override
    public List<StockOrderDetailEntity> filterStockOrderDetail(StockOrderDetailFilterRequest stockOrderDetailFilterRequest) {
        if (stockOrderDetailFilterRequest == null) {
            return Collections.emptyList();
        }
        if (stockOrderDetailFilterRequest.getPage() != null) {
            int offset = (stockOrderDetailFilterRequest.getPage() - 1) * stockOrderDetailFilterRequest.getLimit();
            PageHelper.offsetPage(offset, stockOrderDetailFilterRequest.getLimit());
        }
        return stockOrderDetailDao.filterStockOrderDetail(stockOrderDetailFilterRequest);
    }

    @Override
    public List<StockOrderDetailResponse> filterStockOrderDetail2(StockOrderDetailFilterRequest stockOrderDetailFilterRequest) {
        if (stockOrderDetailFilterRequest == null) {
            return Collections.emptyList();
        }
        if (stockOrderDetailFilterRequest.getPage() != null) {
            int offset = (stockOrderDetailFilterRequest.getPage() - 1) * stockOrderDetailFilterRequest.getLimit();
            PageHelper.offsetPage(offset, stockOrderDetailFilterRequest.getLimit());
        }
        return stockOrderDetailDao.filterStockOrderDetail2(stockOrderDetailFilterRequest);
    }

    @Override
    public boolean insertStockOrderDetail(StockOrderDetailEntity stockOrderDetailEntity) {
        return stockOrderDetailDao.insertStockOrderDetail(stockOrderDetailEntity);
    }

    @Override
    public boolean insertStockOrderDetails(List<StockOrderDetailEntity> StockOrderDetailEntitys) {
        return stockOrderDetailDao.insertStockOrderDetails(StockOrderDetailEntitys);
    }

    @Override
    public boolean updateById(StockOrderDetailEntity stockOrderDetailEntity) {
        return stockOrderDetailDao.updateById(stockOrderDetailEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return stockOrderDetailDao.deleteById(id);
    }
    @Override
    public boolean deleteByOrderIdFk(String id) {
        return stockOrderDetailDao.deleteByOrderIdFk(id);
    }

    @Override
    public StockOrderDetailEntity findOne(String id) {
        return stockOrderDetailDao.findOne(id);
    }

}
