package com.glxp.api.admin.service.business.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.business.StockOrderDetailTempDao;
import com.glxp.api.admin.entity.business.StockOrderDetailEntity;
import com.glxp.api.admin.req.business.StockOrderDetailFilterRequest;
import com.glxp.api.admin.service.business.StockOrderDetailTempService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class StockOrderDetailTempServiceImpl implements StockOrderDetailTempService {

    @Resource
    StockOrderDetailTempDao stockOrderDetailTempDao;

    @Override
    public List<StockOrderDetailEntity> filterStockOrderDetailTemp(StockOrderDetailFilterRequest stockOrderDetailFilterRequest) {
        if (stockOrderDetailFilterRequest == null) {
            return Collections.emptyList();
        }
        if (stockOrderDetailFilterRequest.getPage() != null) {
            int offset = (stockOrderDetailFilterRequest.getPage() - 1) * stockOrderDetailFilterRequest.getLimit();
            PageHelper.offsetPage(offset, stockOrderDetailFilterRequest.getLimit());
        }
        return stockOrderDetailTempDao.filterStockOrderDetailTemp(stockOrderDetailFilterRequest);
    }

    @Override
    public boolean insertStockOrderDetailTemp(StockOrderDetailEntity stockOrderDetailEntity) {
        return stockOrderDetailTempDao.insertStockOrderDetailTemp(stockOrderDetailEntity);
    }

    @Override
    public boolean insertStockOrderDetailTemps(List<StockOrderDetailEntity> StockOrderDetailEntitys) {
        return stockOrderDetailTempDao.insertStockOrderDetailTemps(StockOrderDetailEntitys);
    }

    @Override
    public boolean updateById(StockOrderDetailEntity stockOrderDetailEntity) {
        return stockOrderDetailTempDao.updateById(stockOrderDetailEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return stockOrderDetailTempDao.deleteById(id);
    }
    @Override
    public boolean deleteByOrderIdFk(String id) {
        return stockOrderDetailTempDao.deleteByOrderIdFk(id);
    }

    @Override
    public StockOrderDetailEntity findOne(String id) {
        return stockOrderDetailTempDao.findOne(id);
    }

}
