package com.glxp.api.admin.service.inventory;


import com.glxp.api.admin.entity.inventory.InvWarehouseEntity;
import com.glxp.api.admin.req.basic.FilterBasicThirdSysRequest;
import com.glxp.api.admin.req.inventory.FilterInvWarehouseRequest;
import com.glxp.api.admin.res.inventory.InvWarehouseThirdSysResponse;

import java.util.List;

public interface InvWarehouseService {


    InvWarehouseEntity findDefault(Boolean advaceType, Boolean isDefault);

    List<InvWarehouseEntity> filterInvWarehouse(FilterInvWarehouseRequest filterInvWarehouseRequest);

    List<InvWarehouseEntity> filterGroupInvWarehouse(FilterInvWarehouseRequest filterInvWarehouseRequest);

    boolean insertInvWarehouse(InvWarehouseEntity invWarehouseEntity);

    boolean updateInvWarehouse(InvWarehouseEntity invWarehouseEntity);

    InvWarehouseEntity selectById(String id);

    InvWarehouseEntity selectByCode(String code);

    boolean deleteById(String id);

    /**
     * 绑定第三方仓库
     *
     * @param id
     * @param thridWarehouseId
     */
    boolean bindThrWarehouse(Integer id, Integer thridWarehouseId, String sysId);

    /**
     * 解绑第三方仓库
     *
     * @param id
     * @param thridWarehouseId
     */
    boolean unbindThrWarehouse(Integer id, String sysId);

    /**
     * 查询第三方系统和仓库信息关联数据
     *
     * @param request
     * @param id
     * @return
     */
    List<InvWarehouseThirdSysResponse> getThirdSysDetail(FilterBasicThirdSysRequest request, Integer id);
}
