package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrInvWarehouseDao;
import com.glxp.api.admin.entity.thrsys.ThrInvWarehouseEntity;
import com.glxp.api.admin.req.thrsys.FilterThrInvWarehouseRequest;
import com.glxp.api.admin.service.thrsys.ThrInvWarehouseService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrInvWarehouseServiceImpl implements ThrInvWarehouseService {


    @Resource
    ThrInvWarehouseDao thrInvWarehouseDao;

    @Override
    public ThrInvWarehouseEntity findDefault(Boolean advaceType, Boolean isDefault) {

        FilterThrInvWarehouseRequest filterThrInvWarehouseRequest = new FilterThrInvWarehouseRequest();
        filterThrInvWarehouseRequest.setIsDefault(isDefault);
        filterThrInvWarehouseRequest.setAdvanceType(advaceType);
        List<ThrInvWarehouseEntity> thrInvWarehouseEntities = thrInvWarehouseDao.filterThrInvWarehouse(filterThrInvWarehouseRequest);
        if (thrInvWarehouseEntities != null && thrInvWarehouseEntities.size() > 0)
            return thrInvWarehouseEntities.get(0);
        return null;
    }

    @Override
    public List<ThrInvWarehouseEntity> filterThrInvWarehouse(FilterThrInvWarehouseRequest FilterThrInvWarehouseRequest) {
        if (FilterThrInvWarehouseRequest == null) {
            return Collections.emptyList();
        }
        if (FilterThrInvWarehouseRequest.getPage() != null) {
            int offset = (FilterThrInvWarehouseRequest.getPage() - 1) * FilterThrInvWarehouseRequest.getLimit();
            PageHelper.offsetPage(offset, FilterThrInvWarehouseRequest.getLimit());
        }
        return thrInvWarehouseDao.filterThrInvWarehouse(FilterThrInvWarehouseRequest);
    }

    @Override
    public List<ThrInvWarehouseEntity> filterGroupInvWarehouse(FilterThrInvWarehouseRequest filterThrInvWarehouseRequest) {
        if (filterThrInvWarehouseRequest == null) {
            return Collections.emptyList();
        }
        if (filterThrInvWarehouseRequest.getPage() != null) {
            int offset = (filterThrInvWarehouseRequest.getPage() - 1) * filterThrInvWarehouseRequest.getLimit();
            PageHelper.offsetPage(offset, filterThrInvWarehouseRequest.getLimit());
        }
        return thrInvWarehouseDao.filterThrGroupInvWarehouse(filterThrInvWarehouseRequest);
    }

    @Override
    public boolean insertInvWarehouse(ThrInvWarehouseEntity thrInvWarehouseEntity) {
        return thrInvWarehouseDao.insertThrInvWarehouse(thrInvWarehouseEntity);
    }

    @Override
    public boolean updateInvWarehouse(ThrInvWarehouseEntity thrInvWarehouseEntity) {
        return thrInvWarehouseDao.updateThrInvWarehouse(thrInvWarehouseEntity);
    }

    @Override
    public ThrInvWarehouseEntity selectById(String id) {
        return thrInvWarehouseDao.selectById(id);
    }

    @Override
    public ThrInvWarehouseEntity selectByCode(String code) {
        FilterThrInvWarehouseRequest thrInvWarehouseRequest = new FilterThrInvWarehouseRequest();
        thrInvWarehouseRequest.setCode(code);
        List<ThrInvWarehouseEntity> invWarehouseEntities = thrInvWarehouseDao.filterThrInvWarehouse(thrInvWarehouseRequest);
        if (invWarehouseEntities != null && invWarehouseEntities.size() > 0)
            return invWarehouseEntities.get(0);
        return null;
    }

    @Override
    public boolean deleteById(String id) {
        return thrInvWarehouseDao.deleteById(id);
    }
}
